package ru.dbotthepony.mc.otm.capability.drive;

import net.minecraft.MethodsReturnNonnullByDefault;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import ru.dbotthepony.mc.otm.core.Fraction;
import ru.dbotthepony.mc.otm.storage.*;

import javax.annotation.ParametersAreNonnullByDefault;
import java.math.BigDecimal;
import java.util.List;
import java.util.UUID;

@ParametersAreNonnullByDefault
@MethodsReturnNonnullByDefault
public interface IMatteryDrive<T extends IStorageStack> extends IStorageComponent<T> {
	boolean isDirty();
	void markDirty();
	void markClean();

	Fraction getStoredCount();
	Fraction getCapacity();

	// not extending INBTSerializable to avoid serializing it as forgecaps
	CompoundTag serializeNBT();
	void deserializeNBT(CompoundTag nbt);
}
