package ru.dbotthepony.mc.otm.menu;

import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.inventory.MenuType;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.block.entity.BlockEntity;
import ru.dbotthepony.mc.otm.Registry;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityDriveRack;
import ru.dbotthepony.mc.otm.capability.MatteryCapability;
import ru.dbotthepony.mc.otm.menu.slot.MatterySlot;

import javax.annotation.Nullable;

public class DriveRackMenu extends PoweredMatteryMenu {
	public DriveRackMenu(int p_38852_, Inventory inventory) {
		this(p_38852_, inventory, null);
	}

	public final MatterySlot[] drives = new MatterySlot[4];

	public DriveRackMenu(int p_38852_, Inventory inventory, BlockEntityDriveRack tile) {
		super(Registry.Menus.DRIVE_RACK, p_38852_, inventory, tile);

		var container = tile != null ? tile.drives : new SimpleContainer(4);

		for (int i = 0; i < container.getContainerSize(); i++) {
			drives[i] = new MatterySlot(container, i) {
				@Override
				public boolean mayPlace(ItemStack p_40231_) {
					return p_40231_.getCapability(MatteryCapability.DRIVE).isPresent();
				}
			};

			addSlot(drives[i]);
		}

		addBatterySlot();
		addInventorySlots();
	}

	@Override
	protected int getWorkingSlotStart() {
		return 0;
	}

	@Override
	protected int getWorkingSlotEnd() {
		return 5;
	}
}
