package ru.dbotthepony.mc.otm.menu.widget;

import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.TranslatableComponent;
import ru.dbotthepony.mc.otm.capability.IMatteryEnergyStorage;
import ru.dbotthepony.mc.otm.core.Fraction;
import ru.dbotthepony.mc.otm.menu.FormattingHelper;
import ru.dbotthepony.mc.otm.menu.MatteryMenu;

import javax.annotation.Nullable;
import java.math.BigDecimal;
import java.util.List;
import java.util.function.Supplier;

public class BatteryLevelWidget extends StorageGaugeWidget {
	public BatteryLevelWidget(MatteryMenu menu, int x, int y, IMatteryEnergyStorage capability) {
		super(menu, x, y, capability::getBatteryLevel, capability::getMaxBatteryLevel);
	}

	public BatteryLevelWidget(MatteryMenu menu, IMatteryEnergyStorage capability) {
		super(menu, 0, 0, capability::getBatteryLevel, capability::getMaxBatteryLevel);
	}

	public BatteryLevelWidget(MatteryMenu menu, int x, int y) {
		super(menu, x, y);
	}

	public BatteryLevelWidget(MatteryMenu menu) {
		super(menu, 0, 0);
	}

	public BatteryLevelWidget(MatteryMenu menu, int x, int y, Supplier<Fraction> value_supplier, Supplier<Fraction> max_value_supplier) {
		super(menu, x, y, value_supplier, max_value_supplier);
	}

	@Override
	public int getImageWidth() {
		return 9;
	}

	@Override
	public int getImageHeight() {
		return 48;
	}

	@Override
	public int getImageX() {
		return 0;
	}

	@Override
	public int getImageY() {
		return 48;
	}

	@Nullable
	@Override
	public List<Component> getTooltip() {
		return List.of(
			new TranslatableComponent("otm.gui.power.percentage_level", String.format("%.2f", getLevel() * 100d)),
			FormattingHelper.formatPowerLevel(value_container.getValue(), max_value_container.getValue())
		);
	}
}
