package ru.dbotthepony.mc.otm.menu.data

import net.minecraft.world.inventory.ContainerData
import ru.dbotthepony.mc.otm.core.Fraction
import ru.dbotthepony.mc.otm.network.NetworkHelper

class FractionDataContainer : ContainerData {
	companion object {
		const val NETWORK_PAYLOAD_SIZE = 32
	}

	private var _value: Fraction? = Fraction.ZERO

	fun hasComputedValue(): Boolean {
		return _value != null
	}

	var value: Fraction
		get() {
			if (_value != null)
				return _value!!

			_value = Fraction.fromByteArray(NetworkHelper.shortsToBytes(buffer))
			return _value!!
		}
		set(value) {
			_value = value

			if (_value == null) {
				buffer.fill(0)
				return
			}

			NetworkHelper.bytesToShorts(_value!!.toByteArray()).copyInto(buffer)
		}

	val buffer = ShortArray(NETWORK_PAYLOAD_SIZE)

	override operator fun get(p_39284_: Int): Int {
		return buffer[p_39284_].toInt()
	}

	override operator fun set(p_39285_: Int, p_39286_: Int) {
		buffer[p_39285_] = p_39286_.toShort()
		_value = null
	}

	override fun getCount(): Int {
		return buffer.size
	}
}
